//+------------------------------------------------------------------+
//|                                                CCFp-Modified.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_separate_window
#property indicator_buffers 4
#define USD  0
#define EUR  1
#define GBP  2
#define JPY  3
#define CAD  4
#define AUD  5
#define CHF  6
#define NZD  7
//+-------------------------
//+-------------------------
extern int Mode = 5;

extern int Fast = 3;
extern int Slow = 5;
extern int MA_Method = 3;
extern int Price = 6;
extern string txt2="--------------";
extern int MaHist = 9;
extern int MaHistMethod = 0;
extern int Line_Thickness = 2;
extern int Bars.Count = 2000;
//+-------------------------
//+-------------------------
 bool fgUSD = 1;
 bool fgEUR = 1;
 bool fgGBP = 1;
 bool fgCHF = 1;
 bool fgJPY = 1;
 bool fgAUD = 1;
 bool fgCAD = 1;
 bool fgNZD = 1;
 //+-------------------------
double Buffer0[];
double Buffer1[];
double Buffer2[];
double Buffer3[];

string Currency[8];
double Curency_data[8];
string Symbl[7] = {"EURUSD", "GBPUSD", "USDJPY",
                   "USDCAD","AUDUSD","USDCHF","NZDUSD"}; 
color Color[8];                                       
//+-------------------------
int Buf0 = -1;
int Buf1 = -1;
int k = 1;
int Line0 = DRAW_LINE;
int Line1 = DRAW_LINE;
int Line2 = DRAW_HISTOGRAM;
int Line3 = DRAW_LINE;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
    switch(Mode)
    {
      case 1 : Line0 = DRAW_LINE;
               Line1 = DRAW_NONE;
               Line2 = DRAW_NONE;
               Line3 = DRAW_NONE;
               break;
               
      case 2 : Line0 = DRAW_NONE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_NONE;
               Line3 = DRAW_NONE;
               break;
               
      case 3 : Line0 = DRAW_NONE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_NONE;
               Line3 = DRAW_NONE;
               k = -1;
               break; 
               
      case 4 : Line0 = DRAW_LINE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_NONE;
               Line3 = DRAW_NONE;
               k = -1; 
               break; 
               
      case 5 : Line0 = DRAW_LINE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_HISTOGRAM;
               Line3 = DRAW_LINE;
               k = -1;
               break; 
               
      case 6 : Line0 = DRAW_LINE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_NONE;
               Line3 = DRAW_LINE;
               k = -1;
               break; 
                        
      default: Line0 = DRAW_LINE;
               Line1 = DRAW_LINE;
               Line2 = DRAW_HISTOGRAM;
               Line3 = DRAW_LINE;
               k = 1;                                                        
               break; 
    }
    
   Currency[USD] = "USD";  Color[USD] = DarkGreen;
   Currency[EUR] = "EUR";  Color[EUR] = Blue;
   Currency[GBP] = "GBP";  Color[GBP] = Crimson;
   Currency[JPY] = "JPY";  Color[JPY] = Gold;
   Currency[CAD] = "CAD";  Color[CAD] = DarkSlateBlue;
   Currency[AUD] = "AUD";  Color[AUD] = Purple;
   Currency[CHF] = "CHF";  Color[CHF] = CadetBlue;
   Currency[NZD] = "NZD";  Color[NZD] = Teal;                        
   color Color_Line2 = DarkSlateGray;
   color Color_Line3 = DarkGray;
   
   string Indicator_Name = WindowExpertName();
   IndicatorShortName(Indicator_Name);
   
   
   for(int i = 0; i < 8; i++)
         {
           if(StringFind(Symbol(), Currency[i], 0) == 0) 
                  Buf0 = i;
           if(StringFind(Symbol(), Currency[i], 3) == 3) 
                  Buf1 = i;
          } 
    SetIndexBuffer(0, Buffer0);
    SetIndexStyle (0, Line0, DRAW_LINE, Line_Thickness, Color[Buf0]);
    SetIndexLabel (0, Currency[Buf0]);
       
    SetIndexBuffer(1, Buffer1);
    SetIndexStyle (1, Line1, DRAW_LINE, Line_Thickness, Color[Buf1]);
    SetIndexLabel (1, Currency[Buf1]);   
    
    SetIndexBuffer(2, Buffer2);
    SetIndexStyle (2, Line2, DRAW_HISTOGRAM, 0, Color_Line2);
    SetIndexLabel (2, "Histo");
    
    SetIndexBuffer(3, Buffer3);
    SetIndexStyle (3, Line3, DRAW_LINE, 0, Color_Line3);
    SetIndexLabel (3, "Histo_MA");    
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   if (IndicatorCounted()<0) return(-1);
  limit=Bars-IndicatorCounted();
  if (Bars.Count>0 && limit>Bars.Count) limit=Bars.Count;
//----  
  for(int i = 0; i < limit; i++)
    {
      GetData(Curency_data, i);
      Buffer0[i] = Curency_data[Buf0] ;
      Buffer1[i] = Curency_data[Buf1]* k;
      Buffer2[i] = Curency_data[Buf0] - Curency_data[Buf1];       
    }
    
    for(i = 0; i < limit; i++)
       Buffer3[i] = iMAOnArray(Buffer2,Bars,MaHist,0,MaHistMethod,i);

   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int GetData(double& Curency_data[], int bar)
{
//  
       if(fgEUR)
         {
           double EURUSD_Fast = ma("EURUSD", Fast, MA_Method, Price, bar);
           double EURUSD_Slow = ma("EURUSD", Slow, MA_Method, Price, bar);
           if(!EURUSD_Fast || !EURUSD_Slow)
           return(0);
         }
       if(fgGBP)
         {
           double GBPUSD_Fast = ma("GBPUSD", Fast, MA_Method, Price, bar);
           double GBPUSD_Slow = ma("GBPUSD", Slow, MA_Method, Price, bar);
           if(!GBPUSD_Fast || !GBPUSD_Slow)
           return(0);
         }
       if(fgAUD)
         {
           double AUDUSD_Fast = ma("AUDUSD", Fast, MA_Method, Price, bar);
           double AUDUSD_Slow = ma("AUDUSD", Slow, MA_Method, Price, bar);
           if(!AUDUSD_Fast || !AUDUSD_Slow)
           return(0);
         }
       if(fgNZD)
         {
           double NZDUSD_Fast = ma("NZDUSD", Fast, MA_Method, Price, bar);
           double NZDUSD_Slow = ma("NZDUSD", Slow, MA_Method, Price, bar);
           if(!NZDUSD_Fast || !NZDUSD_Slow)
           return(0);
         }
       if(fgCAD)
         {
           double USDCAD_Fast = ma("USDCAD", Fast, MA_Method, Price, bar);
           double USDCAD_Slow = ma("USDCAD", Slow, MA_Method, Price, bar);
           if(!USDCAD_Fast || !USDCAD_Slow)
           return(0);
         }
       if(fgCHF)
         {
           double USDCHF_Fast = ma("USDCHF", Fast, MA_Method, Price, bar);
           double USDCHF_Slow = ma("USDCHF", Slow, MA_Method, Price, bar);
           if(!USDCHF_Fast || !USDCHF_Slow)
           return(0);
         }
       if(fgJPY)
         {
           double USDJPY_Fast = ma("USDJPY", Fast, MA_Method, Price, bar);
           double USDJPY_Slow = ma("USDJPY", Slow, MA_Method, Price, bar);
           if(!USDJPY_Fast || !USDJPY_Slow)
           return(0);
         }
       
       //  
       if(fgUSD)
         {
           Curency_data[USD] = 0;
           if(fgEUR) 
               Curency_data[USD] += EURUSD_Slow / EURUSD_Fast - 1;
           if(fgGBP) 
               Curency_data[USD] += GBPUSD_Slow / GBPUSD_Fast - 1;
           if(fgAUD) 
               Curency_data[USD] += AUDUSD_Slow / AUDUSD_Fast - 1;
           if(fgNZD) 
               Curency_data[USD] += NZDUSD_Slow / NZDUSD_Fast - 1;
           if(fgCHF) 
               Curency_data[USD] += USDCHF_Fast / USDCHF_Slow - 1;
           if(fgCAD) 
               Curency_data[USD] += USDCAD_Fast / USDCAD_Slow - 1;
           if(fgJPY) 
               Curency_data[USD] += USDJPY_Fast / USDJPY_Slow - 1;
         }// end if USD
       if(fgEUR)
         {
           Curency_data[EUR] = 0;
           if(fgUSD) 
               Curency_data[EUR] += EURUSD_Fast / EURUSD_Slow - 1;
           if(fgGBP) 
               Curency_data[EUR] += (EURUSD_Fast / GBPUSD_Fast) / 
                            (EURUSD_Slow/GBPUSD_Slow) - 1;
           if(fgAUD) 
               Curency_data[EUR] += (EURUSD_Fast / AUDUSD_Fast) / 
                            (EURUSD_Slow/AUDUSD_Slow) - 1;
           if(fgNZD) 
               Curency_data[EUR] += (EURUSD_Fast / NZDUSD_Fast) / 
                            (EURUSD_Slow/NZDUSD_Slow) - 1;
           if(fgCHF) 
               Curency_data[EUR] += (EURUSD_Fast*USDCHF_Fast) / 
                            (EURUSD_Slow*USDCHF_Slow) - 1;
           if(fgCAD) 
               Curency_data[EUR] += (EURUSD_Fast*USDCAD_Fast) / 
                            (EURUSD_Slow*USDCAD_Slow) - 1;
           if(fgJPY) 
               Curency_data[EUR] += (EURUSD_Fast*USDJPY_Fast) / 
                            (EURUSD_Slow*USDJPY_Slow) - 1;
         }// end if EUR
       if(fgGBP)
         {
           Curency_data[GBP] = 0;
           if(fgUSD) 
               Curency_data[GBP] += GBPUSD_Fast / GBPUSD_Slow - 1;
           if(fgEUR) 
               Curency_data[GBP] += (EURUSD_Slow / GBPUSD_Slow) / 
                            (EURUSD_Fast / GBPUSD_Fast) - 1;
           if(fgAUD) 
               Curency_data[GBP] += (GBPUSD_Fast / AUDUSD_Fast) / 
                            (GBPUSD_Slow / AUDUSD_Slow) - 1;
           if(fgNZD) 
               Curency_data[GBP] += (GBPUSD_Fast / NZDUSD_Fast) / 
                            (GBPUSD_Slow / NZDUSD_Slow) - 1;
           if(fgCHF) 
               Curency_data[GBP] += (GBPUSD_Fast*USDCHF_Fast) / 
                            (GBPUSD_Slow*USDCHF_Slow) - 1;
           if(fgCAD) 
               Curency_data[GBP] += (GBPUSD_Fast*USDCAD_Fast) / 
                            (GBPUSD_Slow*USDCAD_Slow) - 1;
           if(fgJPY) 
               Curency_data[GBP] += (GBPUSD_Fast*USDJPY_Fast) / 
                            (GBPUSD_Slow*USDJPY_Slow) - 1;
          }// end if GBP
       if(fgAUD)
         {
           Curency_data[AUD] = 0;
           if(fgUSD) 
               Curency_data[AUD] += AUDUSD_Fast / AUDUSD_Slow - 1;
           if(fgEUR) 
               Curency_data[AUD] += (EURUSD_Slow / AUDUSD_Slow) / 
                            (EURUSD_Fast / AUDUSD_Fast) - 1;
           if(fgGBP) 
               Curency_data[AUD] += (GBPUSD_Slow / AUDUSD_Slow) / 
                            (GBPUSD_Fast / AUDUSD_Fast) - 1;
           if(fgNZD) 
               Curency_data[AUD] += (AUDUSD_Fast/NZDUSD_Fast) / 
                            (AUDUSD_Slow / NZDUSD_Slow) - 1;
           if(fgCHF) 
               Curency_data[AUD] += (AUDUSD_Fast*USDCHF_Fast) / 
                            (AUDUSD_Slow*USDCHF_Slow) - 1;
           if(fgCAD) 
               Curency_data[AUD] += (AUDUSD_Fast*USDCAD_Fast) / 
                            (AUDUSD_Slow*USDCAD_Slow) - 1;
           if(fgJPY) 
               Curency_data[AUD] += (AUDUSD_Fast*USDJPY_Fast) / 
                            (AUDUSD_Slow*USDJPY_Slow) - 1;
         }// end if AUD
       if(fgNZD)
         {
           Curency_data[NZD] = 0;
           if(fgUSD) 
               Curency_data[NZD] += NZDUSD_Fast / NZDUSD_Slow - 1;
           if(fgEUR) 
               Curency_data[NZD] += (EURUSD_Slow / NZDUSD_Slow) / 
                            (EURUSD_Fast/NZDUSD_Fast) - 1;
           if(fgGBP) 
               Curency_data[NZD] += (GBPUSD_Slow / NZDUSD_Slow) / 
                            (GBPUSD_Fast / NZDUSD_Fast) - 1;
           if(fgAUD) 
               Curency_data[NZD] += (AUDUSD_Slow / NZDUSD_Slow) / 
                            (AUDUSD_Fast / NZDUSD_Fast) - 1;
           if(fgCHF) 
               Curency_data[NZD] += (NZDUSD_Fast*USDCHF_Fast) / 
                            (NZDUSD_Slow*USDCHF_Slow) - 1;
           if(fgCAD) 
               Curency_data[NZD] += (NZDUSD_Fast*USDCAD_Fast) / 
                            (NZDUSD_Slow*USDCAD_Slow) - 1;
           if(fgJPY) 
               Curency_data[NZD] += (NZDUSD_Fast*USDJPY_Fast) / 
                            (NZDUSD_Slow*USDJPY_Slow) - 1;
         }// end if NZD
       if(fgCAD)
         {
           Curency_data[CAD] = 0;
           if(fgUSD) 
               Curency_data[CAD] += USDCAD_Slow / USDCAD_Fast - 1;
           if(fgEUR) 
               Curency_data[CAD] += (EURUSD_Slow*USDCAD_Slow) / 
                            (EURUSD_Fast*USDCAD_Fast) - 1;
           if(fgGBP) 
               Curency_data[CAD] += (GBPUSD_Slow*USDCAD_Slow) / 
                            (GBPUSD_Fast*USDCAD_Fast) - 1;
           if(fgAUD) 
               Curency_data[CAD] += (AUDUSD_Slow*USDCAD_Slow) / 
                            (AUDUSD_Fast*USDCAD_Fast) - 1;
           if(fgNZD) 
               Curency_data[CAD] += (NZDUSD_Slow*USDCAD_Slow) / 
                            (NZDUSD_Fast*USDCAD_Fast) - 1;
           if(fgCHF) 
               Curency_data[CAD] += (USDCHF_Fast / USDCAD_Fast) / 
                            (USDCHF_Slow / USDCAD_Slow) - 1;
           if(fgJPY) 
               Curency_data[CAD] += (USDJPY_Fast / USDCAD_Fast) / 
                            (USDJPY_Slow / USDCAD_Slow) - 1;
         }// end if CAD
       if(fgCHF)
         {
           Curency_data[CHF] = 0;
           if(fgUSD) 
               Curency_data[CHF] += USDCHF_Slow / USDCHF_Fast - 1;
           if(fgEUR) 
               Curency_data[CHF] += (EURUSD_Slow*USDCHF_Slow) / 
                            (EURUSD_Fast*USDCHF_Fast) - 1;
           if(fgGBP) 
               Curency_data[CHF] += (GBPUSD_Slow*USDCHF_Slow) / 
                            (GBPUSD_Fast*USDCHF_Fast) - 1;
           if(fgAUD) 
               Curency_data[CHF] += (AUDUSD_Slow*USDCHF_Slow) / 
                            (AUDUSD_Fast*USDCHF_Fast) - 1;
           if(fgNZD) 
               Curency_data[CHF] += (NZDUSD_Slow*USDCHF_Slow) / 
                            (NZDUSD_Fast*USDCHF_Fast) - 1;
           if(fgCAD) 
               Curency_data[CHF] += (USDCHF_Slow / USDCAD_Slow) / 
                            (USDCHF_Fast / USDCAD_Fast) - 1;
           if(fgJPY) 
               Curency_data[CHF] += (USDJPY_Fast / USDCHF_Fast) / 
                            (USDJPY_Slow / USDCHF_Slow) - 1;
         }// end if CHF
       if(fgJPY)
         {
           Curency_data[JPY] = 0;
           if(fgUSD) 
               Curency_data[JPY] += USDJPY_Slow / USDJPY_Fast - 1;
           if(fgEUR) 
               Curency_data[JPY] += (EURUSD_Slow*USDJPY_Slow) / 
                            (EURUSD_Fast*USDJPY_Fast) - 1;
           if(fgGBP) 
               Curency_data[JPY] += (GBPUSD_Slow*USDJPY_Slow) / 
                            (GBPUSD_Fast*USDJPY_Fast) - 1;
           if(fgAUD) 
               Curency_data[JPY] += (AUDUSD_Slow*USDJPY_Slow) / 
                            (AUDUSD_Fast*USDJPY_Fast) - 1;
           if(fgNZD) 
               Curency_data[JPY] += (NZDUSD_Slow*USDJPY_Slow) / 
                            (NZDUSD_Fast*USDJPY_Fast) - 1;
           if(fgCAD) 
               Curency_data[JPY] += (USDJPY_Slow/USDCAD_Slow) / 
                            (USDJPY_Fast/USDCAD_Fast) - 1;
           if(fgCHF) 
               Curency_data[JPY] += (USDJPY_Slow/USDCHF_Slow) / 
                            (USDJPY_Fast/USDCHF_Fast) - 1;
         }// end if JPY
   return(0);      
 }                
//+------------------------------------------------------------------+
//|  Subroutines                                                     |
//+------------------------------------------------------------------+
double ma(string sym, int per, int Mode, int Price, int i)
  {
   double res = 0;
   int k = 1;
   int ma_shift = 0;
   int tf = 0;
   switch(Period())
     {
       case 1:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 5;
       case 5:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 3;
       case 15:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 30:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 60:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 240:   res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 6;
       case 1440:  res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 10080: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k +=4;
       case 43200: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
     } 
   return(res);
  }   
//+------------------------------------------------------------------+
//|                                                                  |         